program sync;

const
  kMaxLights = 100;
  kMaxHours = 5;
  kHour = 60 * 60;
  prob_id = 'F';
  file_id = 'PROBLEM';

type
  CycleArray = array[1..kMaxLights] of integer;


procedure Process (numLights: Integer;
                cycle: CycleArray);

  type
    colour = (green, orange, red);

  var
    time, loop, nextTime: Integer;
    lights: array[1..kMaxLights] of colour;
    allGreen: Boolean;

  procedure WriteTime (var number: Integer;
                  factor: Integer);

    begin
    if (number div factor < 10) then
      write('0');
    write(number div factor:1);
    number := number mod factor;
    end;


  procedure SetState (lightNumber: Integer);

    var
      modTime: Integer;

    begin
    modTime := time mod (2 * cycle[lightNumber]);
    if (modTime < cycle[loop] - 5) then
      lights[lightNumber] := green
    else if (modTime < cycle[loop]) then
      lights[lightNumber] := orange
    else
      lights[lightNumber] := red;
    end;


  begin
  time := MaxInt;
  for loop := 1 to numLights do
    begin
    lights[loop] := green;
    if (cycle[loop] < time) then
      time := cycle[loop];
    end;
  time := time - 5; { Start as first one goes orange }
  allGreen := False;
  while (time <= kMaxHours * kHour) and not allGreen do
    begin
    allGreen := True;
    nextTime := time + 1;
    for loop := 1 to numLights do
      begin
      SetState(loop);
      if (lights[loop] = orange) then
        begin
        if (nextTime < time + cycle[loop]) then
          nextTime := time + cycle[loop];
        end;
      if (lights[loop] <> green) then
        allGreen := False;
      end;
    if not allGreen then
      time := nextTime;
    end;

  if not allGreen then
    begin
    writeln('Signals fail to synchronise in ', kMaxHours:1, ' hours')
    end
  else
    begin
    WriteTime(time, 60 * 60);
    write(':');
    WriteTime(time, 60);
    write(':');
    WriteTime(time, 1);
    writeln
    end;
  end;


procedure DoIt;

  var
    cycles: CycleArray;
    lights, cycle: Integer;

  begin
  read(cycle);
  while (cycle <> 0) do
    begin
    for lights := 1 to kMaxLights do
      cycles[lights] := 0;
    lights := 0;
    while (cycle <> 0) do
      begin
      lights := lights + 1;
      cycles[lights] := cycle;
      read(cycle);
      end;
    Process(lights, cycles);
    read(cycle);
    end;
  end;


begin
DoIt;
end.
