PROGRAM Beggar_My_Neighbour;

#include "str.h"

CONST probname = 'NZ93_';
      prob_id = 'G';
      file_id = 'PROBLEM';
      full_hand = 52;  {52;}
      half_hand = full_hand div 2;

TYPE  link = ^card;
      card = record
               suit, face: char;
               next: link end;
      deck = record count: integer; top, bot: link end;
      index = 0..1;

VAR   debugcounter: integer;
      hand: array[index] of deck;
      stack: deck;
      player, winner: index;
      line: string;
      l: integer;
      thiscard: card;
      done: Boolean;

FUNCTION  ReadDeck: Boolean;     forward;
PROCEDURE SolveProblem;          forward;

PROCEDURE Error(s:string);
begin
  writeln; writeln(s); HALT;
end;

PROCEDURE MainProg;
begin  {Main}

while ReadDeck do
  SolveProblem;

end; {of main procedure}

PROCEDURE readline;
begin readln(line);
line := line + '@'; l := 1 end;

PROCEDURE ReadCard(var p: link);
begin
new(p);
with p^ do begin
  if line[l] = '@' then readline;
  while line[l] = ' ' do Inc(l);
  suit := line[l]; Inc(l);
  face := line[l]; Inc(l);
  end;
end;

PROCEDURE InitDeck(i: index);
begin
with hand[i] do begin
  new(top); ReadCard(top);
  top^.next := nil;
  bot := top end;
end;

PROCEDURE AddToDeck(k: index);
var p: link;
begin
with hand[k] do begin
  new(p); ReadCard(p);
  p^.next := top; top := p end;
end;

function ReadDeck: Boolean;
var i: integer;

begin
readline;
if line[1] = '#'
  then ReadDeck := false
  else begin
    InitDeck(1); InitDeck(0);
    for i := 3 to full_hand do
      AddToDeck(i mod 2);
    hand[0].count := half_hand; hand[1].count := half_hand end;
end;

{**}
PROCEDURE DumpCard(c: card); begin with c do writeln(face, suit, ' '); {readln} end;
PROCEDURE DumpHands;
var p: link; i: index; j:integer;
begin
for i := 0 to 1 do
  with hand[i] do begin j := 0;
    writeln('Hand ', i, ': ', count); p := top;
    if count > 0 then begin
      repeat write(p^.face, p^.suit, ' '); p := p^.next;
        Inc(j); if j mod 26 = 0 then writeln;
        until p = nil;
    writeln end end;
{**}readln;{**}
end;

PROCEDURE DumpStack;
var p: link; j: integer;
begin
with stack do begin writeln('Stack: ', count); j := 0; p := bot;
  repeat write(p^.face, p^.suit, ' '); p := p^.next;
    Inc(j); if j mod 26 = 0 then writeln;
    until p = nil;
  writeln end;
end;
{**}

PROCEDURE InitStack;
begin
with stack do begin
  top := nil; bot := nil; count := 0 end;
end;

PROCEDURE SwitchPlayer; begin player :=  (player + 1) mod 2 end;

PROCEDURE PlayFirstCard;
var p: link;

begin
  with hand[player] do begin
{**write('Starting off - player ', player, ' plays '); DumpCard(top^);{**}
    p := top; top := top^.next;
    with stack do begin
      top := p; bot := p; count := 1; bot^.next := nil end;
    Dec(count) end;
  SwitchPlayer;
end;

PROCEDURE PlayNextCard;
var p: link;

begin
with hand[player] do
  if count = 0
    then begin
{**writeln('Player ', player, ' cannot play');{**}
      done := true; winner := (player+1) mod 2 end
    else begin
{**write('Playing - player ', player, ' plays '); DumpCard(top^);{**}
      p := top; top := top^.next;
      with stack do begin
        top^.next := p; top := p; p^.next := nil; Inc(count) end;
      Dec(count) end;
end;

FUNCTION Honour:Boolean;
begin Honour := (stack.top^.face in ['A', 'K', 'Q', 'J']) end;

PROCEDURE RespondToHonour;
var j: integer;

begin
while Honour and not done do begin
  case stack.top^.face of
    'J': j := 1;
    'Q': j := 2;
    'K': j := 3;
    'A': j := 4
    end;

  repeat Dec(j); PlayNextCard until (j = 0) or Honour or done;
  if not done then SwitchPlayer end;
end;

PROCEDURE XferStack;
begin
{**writeln('Collect cards and add to winner (', player, ')'); DumpStack;{**}
    with hand[player] do
      if count > 0
        then begin
          bot^.next := stack.bot; bot := stack.top; count := count + stack.count;
          bot^.next := nil end
        else begin
          bot := stack.top; top := stack.bot; count := stack.count end;
    InitStack;
{**DumpHands;{**}
end;

PROCEDURE NextPlay;
begin
if stack.count = 0 then PlayFirstCard;
if not Honour
  then begin PlayNextCard; SwitchPlayer end
  else begin RespondToHonour; if not done then XferStack end;
end;

PROCEDURE SolveProblem;
begin
player := 1; InitStack; PlayFirstCard; done := false;
while not done do NextPlay;
writeln(winner+1:1, hand[winner].count:3);
end;

begin mainprog end.

