program Best;

#include "str.h"

const prob_id = 'T';
      file_id = 'PROBLEM';

type
  ListPtr = ^ListRecord;
  ListRecord = record
      fShares: longint;
      fPrice: real;
      fNext: ListPtr;
    end;
var
  stackHead: ListPtr;
  queueHead: ListPtr;
  queueTail: ListPtr;

procedure BuyStack (shares: longint;
                price: real);

  var
    temp: ListPtr;

  begin
  New(temp);
  with temp^ do
    begin
    fShares := shares;
    fPrice := price;
    fNext := stackHead;
    end;
  stackHead := temp;
  end;


procedure BuyQueue (shares: longint;
                price: real);

  begin
  if (queueHead = nil) then
    begin
    New(queueHead);
    queueTail := queueHead;
    end
  else
    begin
    New(queueTail^.fNext);
    queueTail := queueTail^.fNext;
    end;
  with queueTail^ do
    begin
    fShares := shares;
    fPrice := price;
    fNext := nil;
    end;
  end;


procedure CleanUp;

  var
    nuke, mark: ListPtr;

  begin
  mark := stackHead;
  while (mark <> nil) do
    begin
    nuke := mark;
    mark := mark^.fNext;
    Dispose(nuke);
    end;
  mark := queueHead;
  while (mark <> nil) do
    begin
    nuke := mark;
    mark := mark^.fNext;
    Dispose(nuke);
    end;
  stackHead := nil;
  queueHead := nil;
  end;


function Sell (var head: ListPtr;
                numShares: longint;
                price: real): real;

  var
    total: real;
    nuke: ListPtr;

  begin
  total := numShares * price;
  while (numShares > 0) do
    begin
    if (head^.fShares > numShares) then
      with head^ do
        begin
        fShares := fShares - numShares;
        total := total - numShares * fPrice;
        numShares := 0;
        end
    else
      begin
      with head^ do
        begin
        total := total - fShares * fPrice;
        numShares := numShares - fShares;
        end;
      nuke := head;
      head := head^.fNext;
      Dispose(nuke);
      end;
    end;
  Sell := total;
  end;


function SellStack (numShares: longint;
                price: real): real;

  begin
  SellStack := Sell(stackHead, numShares, price);
  end;


function SellQueue (numShares: longint;
                price: real): real;

  begin
  SellQueue := Sell(queueHead, numShares, price);
  end;


procedure DoIt;

  var
    queue, stack: real;
    buySell: char;
    shares: longint;
    price: real;
    name: string;

  begin
  readln(name);
  while (name <> '#') do
    begin
    CleanUp;
    queue := 0;
    stack := 0;
    read(buySell);
    while (buySell <> 'E') do
      begin
      readln(shares, price);
      if (buySell = 'B') then
        begin
        BuyQueue(shares, price);
        BuyStack(shares, price);
        end
      else
        begin
        queue := queue + SellQueue(shares, price);
        stack := stack + SellStack(shares, price);
        end;
      read(buySell);
      end;
    readln;

    write(name, ' ');
    if (stack <= queue) then
      begin
      writeln('LBFS ', stack / 100:9:2)
      end
    else
      begin
      writeln('FBFS ', queue / 100:9:2)
      end;

    readln(name);
    end;
  end;


begin
stackHead := nil;
queueHead := nil;
DoIt;
end.
