program NZ93301;

#include "str.h"

CONST file_id = 'PROBLEM';
      prob_id = 'Z';
 type
  str7 = string;
  wordptr = ^wordrec;
  wordrec = record
    str, nbr: str7;
    left, right: wordptr;
   end;

 var
  digit: array['A'..'Z'] of string;
  matched: integer;

{**********************************************************************}
{                   Mac Pascal String Functions                        }
{**********************************************************************}
function Omit(s: string; start, index: integer): string;
begin Delete(s, start, index); Omit := s end;

procedure readstring(var s: string; var n: integer);
begin
while not (s[1] in ['0'..'9']) do Delete(s, 1, 1);
n := 0;
while (length(s) > 0) and (s[1] in ['0'..'9']) do begin
  n := n*10 + ord(s[1]) - ord('0'); Delete(s, 1, 1) end;
end;
{**********************************************************************}

 procedure ins (var p: wordptr; word: str7);
  var
   i: integer;
 begin
  if p = nil then
   begin
    new(p);
    with p^ do
     begin
      str := word;
      nbr := '';
      for i := length(word) downto 1 do
       nbr := nbr + digit[word[i]];
      left := nil;
      right := nil;
     end;
   end
  else if length(word) < length(p^.str) then
   ins(p^.right, word)
  else if length(word) > length(p^.str) then
   ins(p^.left, word)
  else if word < p^.str then
   ins(p^.left, word)
  else
   ins(p^.right, word);
 end;

 procedure inorder (p: wordptr; back, number: str7);
 begin
  if p <> nil then
   begin
    inorder(p^.left, back, number);
    if matched <= length(p^.str) then
     begin
      if p^.nbr = copy(back, 1, length(p^.str)) then
       begin
       write(' ');
       matched := length(p^.str);
       if matched < 7
         then begin write(copy(number, 1, 7 - matched), '-') end;
       write(p^.str);
       end;
      inorder(p^.right, back, number);
     end;
   end;
 end;

 var
  line: string;
  root: wordptr;
  back, number: str7;
  i: integer;
  ch: char;
begin
 root := nil;
 for ch := 'A' to 'P' do
  digit[ch] := chr(ord('2') + (ord(ch) - ord('A')) div 3);
 for ch := 'R' to 'Y' do
  digit[ch] := chr(ord('7') + (ord(ch) - ord('Q')) div 3);
 digit['Q'] := '1';
 digit['Z'] := '1';
 repeat
  readln(line);
  if not (line[1] in ['0'..'9']) then
   ins(root, line);
 until line[1] in ['0'..'9'];
 repeat
  number := omit(line, 4, 1);
  back := '';
  for i := 7 downto 1 do
   back := back + number[i];
  write(line, ':');
  matched := 0;
  inorder(root, back, number);
  if matched = 0 then
   begin writeln(' No words') end
  else
   writeln;
  readln(line);
 until line = '#';
end.